<?
/* 
-------------------------------------------------------------------------
./logicaland 0.1 - a participative global simulation
-------------------------------------------------------------------------
Copyright (c) 2002 ./logicaland (http://www.logicaland.net)
Michael Aschauer, Josef Deinhofer (io@logicland.net)
-------------------------------------------------------------------------
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "LICENSE.txt," in this distribution.  
-------------------------------------------------------------------------
*/

require("conf/mysql_conf.php");

require("inc/phplib/template.inc");
require("inc/MySQLSession.class.php");


$thread_limit = 10;
$page_limit = 10;


function parseURL($txt)
{
	$regex[http] = "(http|https|ftp|telnet|news):\/\/([a-z0-9_\-]+\.[][a-z0-9:;&#@=_~%\?\/\.\,\+\-]+)";		
	$regex[link] = "(www)(\.[][a-z0-9:;&#@=_~%\?\/\.\,\+\-]+)";
	$regex[email] = "([a-z0-9_\-]+)@([a-z0-9_\-]+\.[a-z0-9\-\._\-]+)";	
	
	$txt = eregi_replace("($regex[http])","<a href=\"\\1\" target=\"_blank\">\\1</a>", $txt);
	// $txt = eregi_replace("($regex[link])","<a href=\"http:\/\\1\" target=\"_blank\">\\1</a>", $txt);
  	$txt = eregi_replace("($regex[email])","<a href=\"mailto:\\1\">\\1</a>", $txt);
	return $txt;
}


$sess= new MySQLSession($mysql_conf);

if (!$sess->isValid($sid)) 
{
	$user_data["name"] = "nobody";
}
else
{
	$user_data = $sess->getUserData();
}



switch($action)
{
	case "send":
		if( !empty($MSG_TEXT) &&  !empty($subject) && !empty($USER_NAME))
		{
			$text = addslashes(strip_tags($MSG_TEXT));
			$subj = addslashes(strip_tags($subject));
		
			$sess->query("INSERT into msg_general 
				set 
				parent_id=0, root_id=0, 
				author='$USER_NAME', text='$text',
				subject='$subj', create_dt=NOW(), modify_dt=NOW()");
			$thr = 0;
		}
		else 
		{
			$error_msg = "please specify all fields !";
			$action = "new";
		}
		
		break;			

	case "del":
	
		if ($sess->isAdmin())
		{
			$row = $sess->singleSelect("SELECT parent_id from msg_general where id=$thr");
			$sess->query("DELETE FROM msg_general where id=$thr");
			$sess->query("DELETE FROM msg_general where parent_id=$thr");
			$thr = $row["parent_id"];
			unset($action);
		}
		break;

	case "reply":
	
		if( !empty($MSG_TEXT) &&  !empty($subject) && !empty($USER_NAME))
		{	
			$text = addslashes(strip_tags($MSG_TEXT));
			$subject = addslashes(strip_tags($subject));
		
			$sess->query("INSERT into msg_general 
					set 
				parent_id=$THREAD_ID, root_id=$THREAD_ID, 
				author=\"$USER_NAME\", text=\"$text\",
				subject=\"$subject\", create_dt=NOW(), modify_dt=NOW()");
			$thr = 0;
			$sess->query("UPDATE msg_general set modify_dt=NOW() where id=$THREAD_ID");
		}
		else 
		{
			$error_msg = "please specify all fields !";
			$thr = $THREAD_ID;
			$action = "new";
		}		
		
		break;		
}





if (!isset($thr)) { $thr = 0; }

if ($action=="new")
{
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/forum_new.html",
		"header" => "tpl/forum_header.html",
		"form" => "tpl/forum_form.html"));

	$tpl->set_var(array(						
		"LINK_NEW_MSG" => "$PHP_SELF".$sess->getSessionString()."&action=new",
		"LINK_FORUM" => "$PHP_SELF".$sess->getSessionString()."&thr=0",							
		)
	);	

	$tpl->set_block("seite","header","head");
	$tpl->set_var(array(
			"USER_NAME" => $user_data["name"],
			"USER_ONLINE" => $sess->getUserOnline(),
			"TITLE" => "FORUM",
			"SESSION_STRING" => $sess->getSessionString()
			)
		);
	$tpl->parse("head","header",true);	
		
	if ($thr != 0)
	{	
		$title = "REPLY MESSAGE";
		$value = "reply";
	}
	else
	{
		$title = "NEW MESSAGE";
		$value = "send";	
	}
	
	
	$tpl->set_block("seite","form","edit");
	$tpl->set_var(array(			
					
		"LINK_NEW_MSG" => "$PHP_SELF".$sess->getSessionString()."&action=new",
		"LINK_FORUM" => "$PHP_SELF".$sess->getSessionString()."&thr=0",						
		"SUBJ" => stripslashes($subject),
		"MSG_TEXT" => stripslashes($MSG_TEXT),		
		"ERROR" => $error_msg,
		"FORM_TITLE" => $title,
		"FORM_ACTION" => $value,
		"NAME" => $user_data["name"],
		"THREAD" => $thr
		)
	);	
	$tpl->parse("edit","form",true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
	exit;
}





if (!$thr)
{
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/forum_main.html",
		"header" => "tpl/forum_header.html"));

	$tpl->set_block("seite","header","head");
	$tpl->set_var(array(
			"USER_NAME" => $user_data["name"],
			"USER_ONLINE" => $sess->getUserOnline(),
			"TITLE" => "FORUM",
			"SESSION_STRING" => $sess->getSessionString()
			)
		);	
	$tpl->parse("head","header",true);
	$tpl->set_block("seite","list","rows");



	$temp_row = $sess->singleSelect("select count(id) from msg_general where parent_id=$thr");
	$thr_num = $temp_row[0];
	$page_num = floor($thr_num / $thread_limit) + ($thr_num % $thread_limit > 0);
	
	$meta_page = floor(($p-1) / $page_limit) + 1;

	if(!isset($p) || $p==0) $p=1;
	//$temp_row = $sess->singleSelect("select count(id) from msg_general");
	//$msg_num = $temp_row[0];

	if($p>1)
		$pages_code .= "<a href=\"forum.php" . $sess->getSessionString() . "&thr=$thr&p=" . ($p-1) . "\" class=\"amenu\"> &lt;&lt; </a>";		

	if ($p>$page_limit)
	{
		$end = min($p + $page_limit - 1 , $page_num);
		$start = max(1,$end - $page_limit + 1);
	}
	else		
	{
		$start = 1;
		$end = min($page_num,$page_limit);
	}

	for($i=$start;$i<=$end;$i++)
	{
		if($i==$p) $pages_code .= "| <font color=\"#ffffff\">$i</font> ";
		else $pages_code .= "| <a href=\"forum.php".$sess->getSessionString()."&thr=$thr&p=$i\" class=\"amenu\"> $i </a> ";
	}	

	if($p<$page_num)
	{
	
		$pages_code .= "| <a href=\"forum.php" . $sess->getSessionString() . "&thr=$thr&p=" . ($p+1) . "\" class=\"amenu\"> &gt;&gt; </a>";	
	}
	else $pages_code .= "|";
		
	
	$min=($p-1)*$thread_limit;
	$max=($p)*$thread_limit;
	
	$result = $sess->query("
		SELECT  id, parent_id, root_id, subject,
			text, author, DATE_FORMAT(create_dt,'%Y-%m-%d %H:%i') as create_dt, DATE_FORMAT(modify_dt,'%Y-%m-%d %H:%i') as modify_dt
		FROM 
			msg_general 
		WHERE  parent_id = 0 
		ORDER BY modify_dt desc
		LIMIT $min, $max");
	
	
	while($row = mysql_fetch_array($result))
	{
	
		$nr_row = $sess->singleSelect("select count(id) as nr from msg_general where root_id=".$row["id"]);
	
		$tpl->set_var(array(
			"NR" => $nr_row["nr"],						
			"LINK_THR" => "$PHP_SELF".$sess->getSessionString()."&thr=".$row["id"],			
			"LINK_NEW_MSG" => "$PHP_SELF".$sess->getSessionString()."&action=new",			
			"SUBJECT" => htmlentities(stripslashes($row["subject"])),
			"FROM" => $row["author"],
			"USER_NAME" => $user_data["name"],
			"USER_ONLINE" => $sess->getUserOnline(),
			"TIME" => $row["modify_dt"],
	
			)
		);
		$tpl->parse("rows","list",true);	
	}		
	
	$row = $sess->singleSelect("SELECT * FROM game_flags");
	
	if ($row["status"]=="running")
	{
		$year_row = $sess->singleSelect("SELECT 
						( TIME_TO_SEC(NOW()) - TIME_TO_SEC(start_time) 
						   + (TO_DAYS(now()) - TO_DAYS(start_time))*1440*60
						) /(interval_time*60) 
						+ preroll 
					as currentYear,
						(interval_time*60) - ( TIME_TO_SEC(NOW()) - TIME_TO_SEC(start_time) + (TO_DAYS(now()) - TO_DAYS(start_time))*1440*60
						) % (interval_time*60) 
					as next_time
					FROM game_flags");
	}
	else
	{
		$year_row = $sess->singleSelect("SELECT actYear as currentYear FROM game_flags");
		$year_row["next_time"] = "";
	}

	$currentYear = floor($year_row["currentYear"]);	
	$next_time = $year_row["next_time"];
	
	$tpl->set_block("seite","gamestatus","cont");	
	$tpl->set_var(array(
			"STATUS" => strtoupper($row["status"]),
			"CURRENT_YEAR" => $currentYear,
			"START_TIME" => $row["start_time"],
			"NEXT_TIME" => $next_time			
		));
	$tpl->parse("cont", "gamestatus", true);	


	$tpl->set_var(array(		
			"LINK_NEW_MSG" => "$PHP_SELF".$sess->getSessionString()."&action=new",
			"MSG_COUNT" => $msg_num,	
			"THREAD_COUNT" => $thr_num,
			"PAGES_CODE" => $pages_code							
			));

	$tpl->parse("out", "seite");
	$tpl->p("out");
}
else
{
	$tpl = new Template();

	$tpl->set_file(array(
		"seite" => "tpl/forum_show_thread.html",
		"header" => "tpl/forum_header.html",
		"form" => "tpl/forum_form.html"));

	$tpl->set_block("seite","header","head");
	$tpl->set_var(array(
			"USER_NAME" => $user_data["name"],
			"USER_ONLINE" => $sess->getUserOnline(),
			"TITLE" => "FORUM",
			"SESSION_STRING" => $sess->getSessionString()
			)
		);
			
	$tpl->parse("head","header",true);
	$tpl->set_block("seite","list","rows");


	$tpl->set_var(array(
			"THREAD_ID" => $thr,
			"ROOT_ID" => $thr,
			"LINK_FORUM" => "$PHP_SELF".$sess->getSessionString()."&thr=0",
			"LINK_NEW_MSG" => "$PHP_SELF".$sess->getSessionString()."&action=new",	
			));
			
	$tpl->set_block("seite","message","rows");

	$result = $sess->query("
			SELECT id, parent_id, root_id, subject,
				text, author, DATE_FORMAT(create_dt,'%Y-%m-%d %H:%i') as create_dt, modify_dt,
				subject
			FROM msg_general
			WHERE  id=$thr or root_id = $thr
			ORDER BY parent_id asc, create_dt asc
			");	
		
	while($row = mysql_fetch_array($result))
	{
		
		$vars = array(					
				"LINK_THR" => "$PHP_SELF".$sess->getSessionString()."&thr=".$row["id"],			
				"SUBJECT" => htmlentities(stripslashes($row["subject"])),
				"FROM" => $row["author"],
				"TIME" => $row["create_dt"],
				"TEXT" => parseUrl(nl2br(htmlentities(stripslashes($row["text"])))),
				);
				
		if ($sess->isAdmin()) 
			$vars["DEL"] = "<a href=\"javascript: delCheck('forum.php".$sess->getSessionString()."&thr=".$row["id"]."&action=del')\" class=\"amenu\">[X]</a>";
		
		$tpl->set_var($vars);
		$tpl->parse("rows","message",true);
		
		$last_subject =  htmlentities(stripslashes($row["subject"]));
	}
	
	$tpl->set_block("seite","form","edit");
	$tpl->set_var(array(												
		"SUBJ" => "re: ".$last_subject ,
		"MSG_TEXT" => $MSG_TEXT,		
		"ERROR" => $error_msg,
		"FORM_TITLE" => "REPLY THIS SUBJECT",
		"FORM_ACTION" => "reply",
		"NAME" => $user_data["name"],
		"THREAD" => $thr,
		"ROOT" => $thr,		
		)
	);	
	$tpl->parse("edit","form",true);
				
	$tpl->parse("out", "seite");
	$tpl->p("out");
}
	
?>
