<?

function _is_valid($string, $min_length, $max_length, $regex)
{
    // Check if the string is empty
    $str = trim($string);
    if(empty($str))
    {
        return(false);
    }

    // Does the string entirely consist of characters of $type?
    if(!eregi("^$regex$", $string))
    {
        return(false);
    }
    
    // Check for the optional length specifiers
    $strlen = strlen($string);
    if(($min_length != 0 && $strlen < $min_length) || ($max_length != 0 && $strlen > $max_length))
    {
        return(false);
    }

    // Passed all tests
    return(true);

}
 

function is_alpha($string, $min_length = 0, $max_length = 0)
{
    $ret = _is_valid($string, $min_length, $max_length, "[[:alpha:]]+");

    return($ret);
}


function is_numeric($string, $min_length = 0, $max_length = 0)
{
    $ret = _is_valid($string, $min_length, $max_length, "[[:digit:]]+");

    return($ret);
}


function is_alphanumeric($string, $min_length = 0, $max_length = 0)
{
    $ret = _is_valid($string, $min_length, $max_length, "[[:alnum:]]+");

    return($ret);
}


function is_email($string)
{
    // Remove whitespace
    $string = trim($string);
    
    $ret = ereg(
                '^([a-z0-9_]|\\-|\\.)+'.
                '@'.
                '(([a-z0-9_]|\\-)+\\.)+'.
                '[a-z]{2,4}$',
                $string);
    
    return($ret);
}


?>
